/*
Copyright 2019 Rancher Labs, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1alpha1

import (
	"context"

	"github.com/rancher/wrangler/pkg/generic"
	v1alpha1 "github.com/rancher/wrangler/sample/pkg/apis/samplecontroller.k8s.io/v1alpha1"
	clientset "github.com/rancher/wrangler/sample/pkg/generated/clientset/versioned/typed/samplecontroller.k8s.io/v1alpha1"
	informers "github.com/rancher/wrangler/sample/pkg/generated/informers/externalversions/samplecontroller.k8s.io/v1alpha1"
	listers "github.com/rancher/wrangler/sample/pkg/generated/listers/samplecontroller.k8s.io/v1alpha1"
	"k8s.io/apimachinery/pkg/api/equality"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/apimachinery/pkg/runtime"
	"k8s.io/apimachinery/pkg/runtime/schema"
	"k8s.io/apimachinery/pkg/types"
	utilruntime "k8s.io/apimachinery/pkg/util/runtime"
	"k8s.io/apimachinery/pkg/watch"
	"k8s.io/client-go/tools/cache"
)

type FooHandler func(string, *v1alpha1.Foo) (*v1alpha1.Foo, error)

type FooController interface {
	FooClient

	OnChange(ctx context.Context, name string, sync FooHandler)
	OnRemove(ctx context.Context, name string, sync FooHandler)
	Enqueue(namespace, name string)

	Cache() FooCache

	Informer() cache.SharedIndexInformer
	GroupVersionKind() schema.GroupVersionKind

	AddGenericHandler(ctx context.Context, name string, handler generic.Handler)
	AddGenericRemoveHandler(ctx context.Context, name string, handler generic.Handler)
	Updater() generic.Updater
}

type FooClient interface {
	Create(*v1alpha1.Foo) (*v1alpha1.Foo, error)
	Update(*v1alpha1.Foo) (*v1alpha1.Foo, error)
	UpdateStatus(*v1alpha1.Foo) (*v1alpha1.Foo, error)
	Delete(namespace, name string, options *metav1.DeleteOptions) error
	Get(namespace, name string, options metav1.GetOptions) (*v1alpha1.Foo, error)
	List(namespace string, opts metav1.ListOptions) (*v1alpha1.FooList, error)
	Watch(namespace string, opts metav1.ListOptions) (watch.Interface, error)
	Patch(namespace, name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.Foo, err error)
}

type FooCache interface {
	Get(namespace, name string) (*v1alpha1.Foo, error)
	List(namespace string, selector labels.Selector) ([]*v1alpha1.Foo, error)

	AddIndexer(indexName string, indexer FooIndexer)
	GetByIndex(indexName, key string) ([]*v1alpha1.Foo, error)
}

type FooIndexer func(obj *v1alpha1.Foo) ([]string, error)

type fooController struct {
	controllerManager *generic.ControllerManager
	clientGetter      clientset.FoosGetter
	informer          informers.FooInformer
	gvk               schema.GroupVersionKind
}

func NewFooController(gvk schema.GroupVersionKind, controllerManager *generic.ControllerManager, clientGetter clientset.FoosGetter, informer informers.FooInformer) FooController {
	return &fooController{
		controllerManager: controllerManager,
		clientGetter:      clientGetter,
		informer:          informer,
		gvk:               gvk,
	}
}

func FromFooHandlerToHandler(sync FooHandler) generic.Handler {
	return func(key string, obj runtime.Object) (ret runtime.Object, err error) {
		var v *v1alpha1.Foo
		if obj == nil {
			v, err = sync(key, nil)
		} else {
			v, err = sync(key, obj.(*v1alpha1.Foo))
		}
		if v == nil {
			return nil, err
		}
		return v, err
	}
}

func (c *fooController) Updater() generic.Updater {
	return func(obj runtime.Object) (runtime.Object, error) {
		newObj, err := c.Update(obj.(*v1alpha1.Foo))
		if newObj == nil {
			return nil, err
		}
		return newObj, err
	}
}

func UpdateFooOnChange(updater generic.Updater, handler FooHandler) FooHandler {
	return func(key string, obj *v1alpha1.Foo) (*v1alpha1.Foo, error) {
		if obj == nil {
			return handler(key, nil)
		}

		copyObj := obj.DeepCopy()
		newObj, err := handler(key, copyObj)
		if newObj != nil {
			copyObj = newObj
		}
		if obj.ResourceVersion == copyObj.ResourceVersion && !equality.Semantic.DeepEqual(obj, copyObj) {
			newObj, err := updater(copyObj)
			if newObj != nil && err == nil {
				copyObj = newObj.(*v1alpha1.Foo)
			}
		}

		return copyObj, err
	}
}

func (c *fooController) AddGenericHandler(ctx context.Context, name string, handler generic.Handler) {
	c.controllerManager.AddHandler(ctx, c.gvk, c.informer.Informer(), name, handler)
}

func (c *fooController) AddGenericRemoveHandler(ctx context.Context, name string, handler generic.Handler) {
	removeHandler := generic.NewRemoveHandler(name, c.Updater(), handler)
	c.controllerManager.AddHandler(ctx, c.gvk, c.informer.Informer(), name, removeHandler)
}

func (c *fooController) OnChange(ctx context.Context, name string, sync FooHandler) {
	c.AddGenericHandler(ctx, name, FromFooHandlerToHandler(sync))
}

func (c *fooController) OnRemove(ctx context.Context, name string, sync FooHandler) {
	removeHandler := generic.NewRemoveHandler(name, c.Updater(), FromFooHandlerToHandler(sync))
	c.AddGenericHandler(ctx, name, removeHandler)
}

func (c *fooController) Enqueue(namespace, name string) {
	c.controllerManager.Enqueue(c.gvk, namespace, name)
}

func (c *fooController) Informer() cache.SharedIndexInformer {
	return c.informer.Informer()
}

func (c *fooController) GroupVersionKind() schema.GroupVersionKind {
	return c.gvk
}

func (c *fooController) Cache() FooCache {
	return &fooCache{
		lister:  c.informer.Lister(),
		indexer: c.informer.Informer().GetIndexer(),
	}
}

func (c *fooController) Create(obj *v1alpha1.Foo) (*v1alpha1.Foo, error) {
	return c.clientGetter.Foos(obj.Namespace).Create(obj)
}

func (c *fooController) Update(obj *v1alpha1.Foo) (*v1alpha1.Foo, error) {
	return c.clientGetter.Foos(obj.Namespace).Update(obj)
}

func (c *fooController) UpdateStatus(obj *v1alpha1.Foo) (*v1alpha1.Foo, error) {
	return c.clientGetter.Foos(obj.Namespace).UpdateStatus(obj)
}

func (c *fooController) Delete(namespace, name string, options *metav1.DeleteOptions) error {
	return c.clientGetter.Foos(namespace).Delete(name, options)
}

func (c *fooController) Get(namespace, name string, options metav1.GetOptions) (*v1alpha1.Foo, error) {
	return c.clientGetter.Foos(namespace).Get(name, options)
}

func (c *fooController) List(namespace string, opts metav1.ListOptions) (*v1alpha1.FooList, error) {
	return c.clientGetter.Foos(namespace).List(opts)
}

func (c *fooController) Watch(namespace string, opts metav1.ListOptions) (watch.Interface, error) {
	return c.clientGetter.Foos(namespace).Watch(opts)
}

func (c *fooController) Patch(namespace, name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.Foo, err error) {
	return c.clientGetter.Foos(namespace).Patch(name, pt, data, subresources...)
}

type fooCache struct {
	lister  listers.FooLister
	indexer cache.Indexer
}

func (c *fooCache) Get(namespace, name string) (*v1alpha1.Foo, error) {
	return c.lister.Foos(namespace).Get(name)
}

func (c *fooCache) List(namespace string, selector labels.Selector) ([]*v1alpha1.Foo, error) {
	return c.lister.Foos(namespace).List(selector)
}

func (c *fooCache) AddIndexer(indexName string, indexer FooIndexer) {
	utilruntime.Must(c.indexer.AddIndexers(map[string]cache.IndexFunc{
		indexName: func(obj interface{}) (strings []string, e error) {
			return indexer(obj.(*v1alpha1.Foo))
		},
	}))
}

func (c *fooCache) GetByIndex(indexName, key string) (result []*v1alpha1.Foo, err error) {
	objs, err := c.indexer.ByIndex(indexName, key)
	if err != nil {
		return nil, err
	}
	for _, obj := range objs {
		result = append(result, obj.(*v1alpha1.Foo))
	}
	return result, nil
}
